import java.util.*;

public class Map<K,V> {
    private ArrayList<Pair<K,V>> list;

    public Map() {
        list = new ArrayList<Pair<K,V>>();
    }

    private int findIndex(K k) {
        for (int i = 0; i < list.size(); i++)
            if (k.equals(list.get(i).getKey())) {
                return i;
            }
        return -1;
    }

    public void put(K k, V v) {
        int idx = this.findIndex(k);
        if (idx == -1)
            list.add(0,new Pair<K,V>(k,v));
        else
            list.get(idx).setVal(v);
    }

    public V get(K k) {
        int idx = this.findIndex(k);
        if (idx == -1)
            return null;
        else
            return list.get(idx).getVal();
    }

    public void delete(K k) {
        int idx = this.findIndex(k);
        if (idx != -1)
            list.remove(idx);
    }

    public boolean isRegistered(K k) {
        return (this.findIndex(k) != -1);
    }

    public String toString() {
        return list.toString();
    }
}
